// V p pxe[uWFl[^

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>

#include "dimiConfigLoader.h"

#define XMAX 128
#define YMAX 192

void GenerateTable(uint8_t *tbl, int xsize, int ysize) {
	double ra;
	int a;
	int x, y;
	int pos;

	for (y = 0; y < ysize; y++) {
		pos = (y & 3) * (ysize >> 2) + (y >> 2);
		for (x = 0; x < xsize; x++) {
			pos = (x >> 4) * 3072 +
			      (y     ) *   16 +
			      (x & 15);
			if ((x > 0) && (y > 0)) {
				ra = atan2((double)y, (double)x);
				a = (int)(ra * 64.0 / (M_PI / 2.0) + 0.5);
				if ((a < 0) || (a > 64)) printf("a = %d\n", a);
				tbl[pos] = (uint8_t)(192 - a);
			} else if (x > 0) {
				tbl[pos] = 192;
			} else if (y > 0) {
				tbl[pos] = 128;
			} else {
				tbl[pos] = 128;
			}
		}
	}

}

void WriteBinary(char *path, uint8_t *buf, int size) {
	FILE *fp;

	fp = fopen(path, "wb");
	if (fp) {
		fwrite(buf, sizeof(uint8_t), size, fp);
		fclose(fp);
	}
}

int main(int argc, char *argv[]) {
	uint8_t tbl[XMAX*YMAX];
	void *conf;
	char *p;
	int r;

	if (argc < 2) {
		printf("Usage: %s <ݒt@C>\n", argv[0]);
		return 1;
	}

	r = DimiConf_Open(&conf, argv[1]);
	if (r) {
		printf("t@CI[vG[: %s\n", argv[1]);
		return 1;
	}

	GenerateTable(tbl, XMAX, YMAX);

	p = DimiConf_GetString(conf, "", "name0", (char *)"atan0.bin");
	WriteBinary(p, tbl+3072*0, 3072);
	p = DimiConf_GetString(conf, "", "name1", (char *)"atan1.bin");
	WriteBinary(p, tbl+3072*1, 3072);
	p = DimiConf_GetString(conf, "", "name2", (char *)"atan2.bin");
	WriteBinary(p, tbl+3072*2, 3072);
	p = DimiConf_GetString(conf, "", "name3", (char *)"atan3.bin");
	WriteBinary(p, tbl+3072*3, 3072);
	p = DimiConf_GetString(conf, "", "name4", (char *)"atan4.bin");
	WriteBinary(p, tbl+3072*4, 3072);
	p = DimiConf_GetString(conf, "", "name5", (char *)"atan5.bin");
	WriteBinary(p, tbl+3072*5, 3072);
	p = DimiConf_GetString(conf, "", "name6", (char *)"atan6.bin");
	WriteBinary(p, tbl+3072*6, 3072);
	p = DimiConf_GetString(conf, "", "name7", (char *)"atan7.bin");
	WriteBinary(p, tbl+3072*7, 3072);

	DimiConf_Close(conf);

	return 0;
}

